// OctPOUDoc.cpp : COctPOUDoc 
//

#include "stdafx.h"
#include "OctPOU.h"

#include "OctPOUDoc.h"
#include "OctPOUView.h"

#include <time.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static char file_ex[] = "All files(*.*)|*.*||";

/////////////////////////////////////////////////////////////////////////////
// COctPOUDoc

IMPLEMENT_DYNCREATE(COctPOUDoc, CDocument)

BEGIN_MESSAGE_MAP(COctPOUDoc, CDocument)
	//{{AFX_MSG_MAP(COctPOUDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_TIME, OnTime)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_POLYGONIZE, OnPolygonize)
	ON_COMMAND(ID_FLAT, OnFlat)
	ON_COMMAND(ID_POINT, OnPoint)
	ON_COMMAND(ID_WIRE, OnWire)
	ON_COMMAND(ID_CONF, OnConf)
	ON_COMMAND(ID_SMOOTH, OnSmooth)
	ON_COMMAND(ID_FLAT_GRADIENT, OnFlatGradient)
	ON_COMMAND(ID_BOOL, OnBool)
	ON_COMMAND(ID_OPEN_2, OnOpen2)
	ON_COMMAND(ID_MORPH, OnMorph)
	ON_COMMAND(ID_SMOOTH_NORMAL, OnSmoothNormal)
	ON_COMMAND(ID_RAYTRACE, OnRaytrace)
	ON_COMMAND(ID_MOVE, OnMove)
	ON_COMMAND(ID_MERGE, OnMerge)
	ON_COMMAND(SAVE_POINT1, OnPoint1)
	ON_COMMAND(SAVE_POINT2, OnPoint2)
	ON_COMMAND(ID_LEVEL, OnLevel)
	ON_COMMAND(ID_FUNC, OnFunc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COctPOUDoc

COctPOUDoc::COctPOUDoc()
{
	_func = NULL;
	_func2 = NULL;
	_mesh = NULL;
	_ps = NULL;
	_ps2 = NULL;
	_ps2_tmp = NULL;
	_ray_ps = NULL;

	//Dialogs
	tdia = new TimeDialog;
	poly_dia = new PolygonizationDialog;
	bool_dia = new BooleanDialog;
	blend_dia = new BlendingDialog;
	bound_dia = new BoundDialog;
	move_dia = new MoveDialog;
	move_dia->doc = this;
	func_dia = new FunctionDialog;
}

COctPOUDoc::~COctPOUDoc()
{
	if(_func != NULL)
		delete _func;
	if(_func2 != NULL)
		delete _func2;
	if(_mesh != NULL)
		delete _mesh;
	if(_ps != NULL)
		delete _ps;
	if(_ps2 != NULL)
		delete _ps2;
	if(_ray_ps != NULL)
		delete _ray_ps;

	delete tdia;
	delete poly_dia;
	delete bool_dia;
	delete blend_dia;
	delete bound_dia;
	delete move_dia;
	delete func_dia;
}

BOOL COctPOUDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// COctPOUDoc 
void COctPOUDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// COctPOUDoc 

#ifdef _DEBUG
void COctPOUDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void COctPOUDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COctPOUDoc

void COctPOUDoc::OnFileOpen() 
{
	// TODO: 
	
	//Read point date from specified file
	CFileDialog dia(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		            file_ex, NULL);
	if(dia.DoModal() != IDOK){
		return;
	}
	BeginWaitCursor();

	CString name = dia.GetPathName();
	FileManager fm;

	if(_ps != NULL){
		delete _ps;
		_ps = NULL;
		if(_func != NULL){
			delete _func;
			_func = NULL;
		}
		if(_mesh != NULL){
			delete _mesh;
			_mesh = NULL;
		}
	}

	_ps = new PointSet;
	fm.readPointFile(_ps, name);

	EndWaitCursor();

	CMDIFrameWnd *pFrame = 
             (CMDIFrameWnd*)AfxGetApp()->m_pMainWnd;

   // Get the active MDI child window.
   CMDIChildWnd *pChild = 
             (CMDIChildWnd *) pFrame->GetActiveFrame();

    file_data = dia.GetFileName() + "     #points: ";
	CString s2;
	s2.Format("%d", _ps->_pointN);
    file_data += s2;
    pChild->SetWindowText(file_data);

	mode = POINT;
	draw();
}

void COctPOUDoc::OnTime() 
{
	// TODO: 
	tdia->DoModal();
}

void COctPOUDoc::OnFileSaveAs() 
{
	// TODO:
	if(_mesh == NULL)
		return;

	CFileDialog dia(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		            file_ex, NULL);
	if(dia.DoModal() != IDOK){
		return;
	}
	CString name = dia.GetPathName();
	FileManager fm;
	if(_mesh->normal == NULL)
		fm.writeMeshFile(_mesh, name + ".poly");
	else
		fm.writeMeshFile(_mesh, name + ".polyWithN");
}

void COctPOUDoc::OnPolygonize() 
{
	// TODO: 

	if(_ps == NULL)
		return;

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);

	//First polygonization case
	//Bounding box data is set to GUI
	if(_mesh == NULL){
		poly_dia->m_x1 = min[0];
		poly_dia->m_y1 = min[1];
		poly_dia->m_z1 = min[2];

		poly_dia->m_x2 = max[0];
		poly_dia->m_y2 = max[1];
		poly_dia->m_z2 = max[2];
	}

	if(poly_dia->DoModal() != IDOK)
		return;

	BeginWaitCursor();
	clock_t start = clock();

	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - size;
	minC[1] = mid[1] - size;
	minC[2] = mid[2] - size;
	maxC[0] = mid[0] + size;
	maxC[1] = mid[1] + size;
	maxC[2] = mid[2] + size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
		_func->imp->_support = func_dia->m_support;
		_func->imp->_Nmin = func_dia->m_nmin;
		_func->imp->_lambda = func_dia->m_lambda;
		_func->imp->_sharp = (func_dia->m_sharp == TRUE);
		_func->imp->_edgeT = func_dia->m_edge;
		_func->imp->_cornerT = func_dia->m_corner;
	}
	
	_func->_max_level = poly_dia->m_level;
	_func->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func->_iso = poly_dia->m_iso*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);

	//Polygonization
	
	Polygonizer poly;
	poly.func = _func;
	float box[] = {poly_dia->m_x2, poly_dia->m_x1,
				   poly_dia->m_y2, poly_dia->m_y1,
				   poly_dia->m_z2, poly_dia->m_z1};
	
	int N = _ps->_pointN;
	float boxC[] = {0.5f*(box[0]+box[1]), 0.5f*(box[2]+box[3]), 0.5f*(box[4]+box[5])};
	for(int i=0; i<N; i++){
		float *p = _ps->_point[i];
		if(p[0] < box[0] && p[0] > box[1] &&
		   p[1] < box[2] && p[1] > box[3] &&
		   p[2] < box[4] && p[2] > box[5]){
			boxC[0] = p[0];
			boxC[1] = p[1];
			boxC[2] = p[2];

			break;
		}
	}
	
	_func->count = 0;

	if(_mesh != NULL)
		delete _mesh;

	_mesh = poly.bloomenthal(poly_dia->m_grid*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ), boxC, box);

	//Timing & #Evaluation
	tdia = new TimeDialog;

	clock_t duration = clock() - start;
	float t = (float)(duration/ CLOCKS_PER_SEC);
	EndWaitCursor();

	tdia->m_time = t;
	tdia->m_function = _func->count;
	tdia->m_cell = _func->getCellCount();

	CMDIFrameWnd *pFrame = 
             (CMDIFrameWnd*)AfxGetApp()->m_pMainWnd;

	// Get the active MDI child window.
	CMDIChildWnd *pChild = 
				(CMDIChildWnd *) pFrame->GetActiveFrame();

	CString s2;
	s2.Format("%d", _mesh->face_N);
    CString s1 = file_data + "    #triangles:" + s2;
    pChild->SetWindowText(s1);
	

	mode = FLAT;
	draw();
}

void COctPOUDoc::OnFlat() 
{
	// TODO: 
	if(_mesh == NULL)
		return;
	_mesh->computeFaceNormal();
	mode = FLAT;
	draw();
}

void COctPOUDoc::OnPoint() 
{
	// TODO: 
	mode = POINT;
	draw();
}

void COctPOUDoc::OnWire() 
{
	// TODO: 
	mode = WIRE;
	draw();
}

void COctPOUDoc::drawMesh()
{
	POSITION pos = GetFirstViewPosition();
	COctPOUView* pView = (COctPOUView*)GetNextView(pos);
	switch(mode){
	case FLAT:
		/*
		if(_ps == NULL)
			return;
		pView->drawPointOutOfBox(_ps, 
			                     poly_dia->m_x1, poly_dia->m_x2,
								 poly_dia->m_y1, poly_dia->m_y2,
								 poly_dia->m_z1, poly_dia->m_z2);
		*/
		if(_mesh == NULL)
			return;
		if(_mesh->normal_f == NULL){
			_mesh->computeFaceNormal();
		}
		pView->flatShade(_mesh);
		break;
	case WIRE:
		if(_mesh == NULL)
			return;
		if(_mesh->normal_f == NULL)
			_mesh->computeFaceNormal();
		if(_mesh->normal == NULL)
			_mesh->computeNormal();
		pView->wireframe(_mesh);
		break;
	case POINT:
		if(_ps != NULL)
			pView->drawPoint(_ps);

		if(_ps2 != NULL){
			if(_ps2_tmp == NULL)
				pView->drawPoint(_ps2);
			else
				pView->drawPoint(_ps2_tmp);
		}

		break;
	case CONF:
		if(_ps == NULL)
			return;
		pView->drawConfidence(_ps);
		break;
	case SMOOTH:
		if(_mesh == NULL)
			return;
		if(_mesh->normal == NULL)
			_mesh->computeNormal();
		pView->smoothShade(_mesh);
		break;
	case RAY:
		if(_ray_ps == NULL)
			return;
		pView->drawPoint(_ray_ps);
		break;
	}
}

void COctPOUDoc::draw()
{
	POSITION pos = GetFirstViewPosition();
	COctPOUView* pView = (COctPOUView*)GetNextView(pos);
	if(mode == POINT && _ps != NULL){
		pView->vertex_N = _ps->_pointN;
	}
	else if(_mesh != NULL){
		pView->face_N = _mesh->face_N;
		pView->vertex_N = _mesh->vertex_N;
	}
	pView->draw();
}

void COctPOUDoc::OnConf() 
{
	// TODO: 
	if(_ps == NULL)
		return;

	if(bound_dia->DoModal() != IDOK)
		return;

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);
	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}

	/*
	PointSet* qs = _func->imp->computeConfidence(poly_dia->m_level);
	delete _ps;
	_ps = qs;
	delete _func;
	_func = NULL;*/

	_func->imp->computeConfidence(bound_dia->m_level, bound_dia->m_T);
	mode = CONF;

	draw();
	return;
}

void COctPOUDoc::OnSmooth() 
{
	// TODO: 
	if(_mesh == NULL)
		return;

	int vertex_N = _mesh->vertex_N;
	float (*vertex)[3] = _mesh->vertex;
	_mesh->computeNormal();
	float (*normal)[3] = _mesh->normal;

	for(int i=0; i<vertex_N; i++){
		float* n = normal[i];
		_func->gradient(n, vertex[i][0], vertex[i][1], vertex[i][2]);
		float len = -(float)sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
		if(len != 0){
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
		}
	}

	mode = SMOOTH;
	draw();
}

void COctPOUDoc::OnFlatGradient() 
{
	// TODO: 
	if(_mesh == NULL)
		return;

	int face_N = _mesh->face_N;
	_mesh->computeCenter();
	float (*center)[3] = _mesh->center;
	_mesh->computeFaceNormal();
	float (*normal)[3] = _mesh->normal_f;

	for(int i=0; i<face_N; i++){
		float* n = normal[i];
		_func->gradient(n, center[i][0], center[i][1], center[i][2]);
		float len = -(float)sqrt(n[0]*n[0] + n[1]*n[1] + n[2]*n[2]);
		if(len != 0){
			n[0] /= len;
			n[1] /= len;
			n[2] /= len;
		}
	}

	mode = FLAT;
	draw();
}

void COctPOUDoc::OnBool() 
{
	// TODO: 
	if(_ps == NULL || _ps2 == NULL)
		return;

	if(bool_dia->DoModal() != IDOK)
		return;

	if(poly_dia->DoModal() != IDOK)
		return;

	clock_t start = clock();

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);
	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}
	
	_func->_max_level = poly_dia->m_level;
	_func->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func->_iso = poly_dia->m_iso;
	
	//Bounding box data
	float min2[3], max2[3];
	_ps2->bound(min2, max2);
	float mid2[3];
	mid2[0] = 0.5f*(min2[0] + max2[0]);
	mid2[1] = 0.5f*(min2[1] + max2[1]);
	mid2[2] = 0.5f*(min2[2] + max2[2]);

	sizeX = max2[0] - min2[0];
	sizeY = max2[1] - min2[1];
	sizeZ = max2[2] - min2[2];
	float size2 = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	minC[0] = mid2[0] - 1.05f*size2;
	minC[1] = mid2[1] - 1.05f*size2;
	minC[2] = mid2[2] - 1.05f*size2;
	maxC[0] = mid2[0] + 1.05f*size2;
	maxC[1] = mid2[1] + 1.05f*size2;
	maxC[2] = mid2[2] + 1.05f*size2;

	if(_func2 == NULL){
		_func2 = new ImplicitPOU;
		_func2->imp = new ImplicitOctTree(_ps2, minC, maxC);
		_func2->setMaxCellN(10000000);
	}
	
	_func2->_max_level = poly_dia->m_level;
	_func2->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func2->_iso = poly_dia->m_iso;

	//boolean operation
	BooleanImplicit bfunc;
	bfunc.setOP(bool_dia->m_op);
	if(bool_dia->m_blend)
		bfunc.setBlenging(bool_dia->m_a0, 
						  bool_dia->m_a1, bool_dia->m_a2, bool_dia->m_R);
	bfunc.f1 = _func;
	bfunc.f2 = _func2;

	//Polygonization
	Polygonizer poly;
	poly.func = &bfunc;
	float box[] = {max(max[0], max2[0]) + 0.05f*size, 
				   min(min[0], min2[0]) - 0.05f*size,

		           max(max[1], max2[1]) + 0.05f*size, 
				   min(min[1], min2[1]) - 0.05f*size,

				   max(max[2], max2[2]) + 0.05f*size, 
				   min(min[2], min2[2]) - 0.05f*size};
	_func->count = 0;

	if(_mesh != NULL)
		delete _mesh;

	_mesh = poly.bloomenthal(poly_dia->m_grid, _ps->_point[_ps->_pointN/2], box);

	//Timing & #Evaluation
	tdia = new TimeDialog;

	clock_t duration = clock() - start;
	float t = (float)(duration/ CLOCKS_PER_SEC);

	tdia->m_time = t;
	tdia->m_function = _func->count;
	tdia->m_cell = _func->getCellCount();

	mode = FLAT;
	draw();
}

void COctPOUDoc::OnOpen2() 
{
	// TODO: 
	//Read point date from specified file
	CFileDialog dia(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		            file_ex, NULL);
	if(dia.DoModal() != IDOK){
		return;
	}
	CString name = dia.GetPathName();
	FileManager fm;

	if(_ps2 != NULL){
		delete _ps2;
		_ps2 = NULL;
		if(_func != NULL){
			delete _func;
			_func = NULL;
		}
	}

	_ps2 = new PointSet;
	fm.readPointFile(_ps2, name);

	mode = POINT;
	draw();
}

void COctPOUDoc::OnMorph() 
{
	// TODO: 
	if(_ps == NULL || _ps2 == NULL)
		return;

	if(blend_dia->DoModal() != IDOK)
		return;

	if(poly_dia->DoModal() != IDOK)
		return;

	clock_t start = clock();

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);
	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}
	
	_func->_max_level = poly_dia->m_level;
	_func->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func->_iso = poly_dia->m_iso;
	
	//Bounding box data
	float min2[3], max2[3];
	_ps2->bound(min2, max2);
	float mid2[3];
	mid2[0] = 0.5f*(min2[0] + max2[0]);
	mid2[1] = 0.5f*(min2[1] + max2[1]);
	mid2[2] = 0.5f*(min2[2] + max2[2]);

	sizeX = max2[0] - min2[0];
	sizeY = max2[1] - min2[1];
	sizeZ = max2[2] - min2[2];
	float size2 = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	minC[0] = mid2[0] - 1.05f*size2;
	minC[1] = mid2[1] - 1.05f*size2;
	minC[2] = mid2[2] - 1.05f*size2;
	maxC[0] = mid2[0] + 1.05f*size2;
	maxC[1] = mid2[1] + 1.05f*size2;
	maxC[2] = mid2[2] + 1.05f*size2;

	if(_func2 == NULL){
		_func2 = new ImplicitPOU;
		_func2->imp = new ImplicitOctTree(_ps2, minC, maxC);
		_func2->setMaxCellN(10000000);
	}
	
	_func2->_max_level = poly_dia->m_level;
	_func2->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func2->_iso = poly_dia->m_iso;

	//boolean operation
	BlendingImplicit bfunc;
	bfunc.time = blend_dia->m_time;
	bfunc.f1 = _func;
	bfunc.f2 = _func2;

	//Polygonization
	Polygonizer poly;
	poly.func = &bfunc;
	float box[] = {max(max[0], max2[0]) + 0.05f*size, 
				   min(min[0], min2[0]) - 0.05f*size,

		           max(max[1], max2[1]) + 0.05f*size, 
				   min(min[1], min2[1]) - 0.05f*size,

				   max(max[2], max2[2]) + 0.05f*size, 
				   min(min[2], min2[2]) - 0.05f*size};
	_func->count = 0;

	if(_mesh != NULL)
		delete _mesh;

	_mesh = poly.bloomenthal(poly_dia->m_grid, _ps->_point[_ps->_pointN/2], box);

	//Timing & #Evaluation
	tdia = new TimeDialog;

	clock_t duration = clock() - start;
	float t = (float)(duration/ CLOCKS_PER_SEC);

	tdia->m_time = t;
	tdia->m_function = _func->count;
	tdia->m_cell = _func->getCellCount();

	mode = FLAT;
	draw();
}

void COctPOUDoc::OnSmoothNormal() 
{
	if(_ps == NULL)
		return;

	if(bound_dia->DoModal() != IDOK)
		return;

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);
	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}

	
	_func->imp->smoothNormal(bound_dia->m_level);
	
	mode = POINT;

	draw();
	return;
}

void COctPOUDoc::OnRaytrace() 
{
	if(_ps == NULL)
		return;

	if(poly_dia->DoModal() != IDOK)
		return;

	clock_t start = clock();

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);
	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}
	_func->_max_level = poly_dia->m_level;
	_func->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func->_iso = poly_dia->m_iso;
	_func->count = 0;

	RayTracer ray;
	ray.setFunc(_func);
	ray.createImage("test.ppm");

	/*
	if(_ray_ps != NULL)
		delete _ray_ps;

	_ray_ps = new PointSet;
	int N = 100;
	int M = 100;
	_ray_ps->setPointSize(N*M);

	float o[] = {0,0,40};
	float x, y, z;
	z = 0;

	int count = 0;
	for(int i=0; i<N; i++){
		y = -10.0f + 20.0f*i/N;
		for(int j=0; j<M; j++){
			x = -10.0f + 20.0f*j/M;
			float len = (float)sqrt((x-o[0])*(x-o[0]) + 
									(y-o[1])*(y-o[1]) +
									(z-o[2])*(z-o[2]));

			float d[3];
			d[0] = (x-o[0])/len;
			d[1] = (y-o[1])/len;
			d[2] = (z-o[2])/len;
			
			float p[3], n[3];
			if(_func->searchZeroOnLine(p, n, o, d)){
				_ray_ps->setPoint(count, p[0], p[1], p[2]);
				_ray_ps->setNormal(count, n[0], n[1], n[2]);
				count++;
			}
		}
		_ray_ps->_pointN = count;
		mode = RAY;
		draw();
	}
	_ray_ps->_pointN = count;
*/
	//Timing & #Evaluation
	tdia = new TimeDialog;

	clock_t duration = clock() - start;
	float t = (float)(duration/ CLOCKS_PER_SEC);

	tdia->m_time = t;
	tdia->m_function = _func->count;
	tdia->m_cell = _func->getCellCount();

	//mode = RAY;
	//draw();
	return;
}

void COctPOUDoc::moveSecondPoints()
{
	if(_ps2_tmp != NULL){
		delete _ps2_tmp;
		_ps2_tmp = NULL;
	}
	_ps2->scale(move_dia->m_s);
	_ps2->rotate(move_dia->m_rx, move_dia->m_ry, move_dia->m_rz);
	_ps2->shift(move_dia->m_sx, move_dia->m_sy, move_dia->m_sz);
	draw();
}

void COctPOUDoc::OnMove() 
{
	// TODO: 
	if(_ps2 == NULL)
		return;
	move_dia->ShowWindow(SW_SHOWNORMAL);
}

void COctPOUDoc::createTempPS2()
{
	if(_ps2_tmp != NULL)
		delete _ps2_tmp;
	_ps2_tmp = _ps2->copyPoints();
	_ps2_tmp->scale(move_dia->m_s);
	_ps2_tmp->rotate(move_dia->m_rx, move_dia->m_ry, move_dia->m_rz);
	_ps2_tmp->shift(move_dia->m_sx, move_dia->m_sy, move_dia->m_sz);
	draw();
}

void COctPOUDoc::OnMerge() 
{
	// TODO: 
	if(_ps == NULL || _ps2 == NULL)
		return;

	if(bool_dia->DoModal() != IDOK)
		return;

	if(poly_dia->DoModal() != IDOK)
		return;

	clock_t start = clock();

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);
	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}
	
	_func->_max_level = poly_dia->m_level;
	_func->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func->_iso = poly_dia->m_iso;
	
	//Bounding box data
	float min2[3], max2[3];
	_ps2->bound(min2, max2);
	float mid2[3];
	mid2[0] = 0.5f*(min2[0] + max2[0]);
	mid2[1] = 0.5f*(min2[1] + max2[1]);
	mid2[2] = 0.5f*(min2[2] + max2[2]);

	sizeX = max2[0] - min2[0];
	sizeY = max2[1] - min2[1];
	sizeZ = max2[2] - min2[2];
	float size2 = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	minC[0] = mid2[0] - 1.05f*size2;
	minC[1] = mid2[1] - 1.05f*size2;
	minC[2] = mid2[2] - 1.05f*size2;
	maxC[0] = mid2[0] + 1.05f*size2;
	maxC[1] = mid2[1] + 1.05f*size2;
	maxC[2] = mid2[2] + 1.05f*size2;

	if(_func2 == NULL){
		_func2 = new ImplicitPOU;
		_func2->imp = new ImplicitOctTree(_ps2, minC, maxC);
		_func2->setMaxCellN(10000000);
	}
	
	_func2->_max_level = poly_dia->m_level;
	_func2->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func2->_iso = poly_dia->m_iso;

	//boolean operation

	BooleanImplicit bfunc;
	bfunc.setOP(bool_dia->m_op);
	/*
	if(bool_dia->m_blend)
		bfunc.setBlenging(bool_dia->m_a0, 
						  bool_dia->m_a1, bool_dia->m_a2);
	bfunc.f1 = _func;
	bfunc.f2 = _func2;*/

	//evaluation
	int N1 = _ps->_pointN;
	int N2 = _ps2->_pointN;
	
	PointSet* new_ps = new PointSet;
	new_ps->setPointSize(N1+N2);

	float (*p1)[3] = _ps->_point;
	float (*n1)[3] = _ps->_normal;
	float (*p2)[3] = _ps2->_point;
	float (*n2)[3] = _ps2->_normal;

	bool isUnion = bfunc.isUnion;
	bool reversef2 = bfunc.isReversef2;

	int count = 0;

	//Primal points
	for(int i=0; i<N1; i++){
		float *p = p1[i];
		
		bool flag = false;
		if(isUnion){
			/*
			if(!_func2->isIn(p[0], p[1], p[2]))
				flag = true;
			else{*/
				float v1 = _func->value(p[0], p[1], p[2]);
				float v2 = _func2->value(p[0], p[1], p[2]);

				if(v1 > v2)
					flag = true;
			//}
		}
		else{
			/*
			if(!_func2->isIn(p[0], p[1], p[2]))
				flag = reversef2;
			else{*/
				float v1 = _func->value(p[0], p[1], p[2]);
				float v2 = _func2->value(p[0], p[1], p[2]);

				if(reversef2)
					v2 = -v2;

				if(v1 < v2)
					flag = true;
			//}
		}
		if(flag){
			new_ps->setPoint(count, p[0], p[1], p[2]);
			new_ps->setNormal(count, n1[i][0], n1[i][1], n1[i][2]);
			count++;
		}
	}

	//Second points
	for(i=0; i<N2; i++){
		float *p = p2[i];
	
		bool flag = false;
		if(isUnion){
			/*
			if(!_func->isIn(p[0], p[1], p[2]))
				flag = true;
			else{*/
				float v1 = _func->value(p[0], p[1], p[2]);
				float v2 = _func2->value(p[0], p[1], p[2]);

				if(v1 < v2)
					flag = true;
			//}
		}
		else{
			/*
			if(!_func->isIn(p[0], p[1], p[2]))
				flag = false;
			else{*/
				float v1 = _func->value(p[0], p[1], p[2]);
				float v2 = _func2->value(p[0], p[1], p[2]);

				if(reversef2)
					v2 = -v2;

				if(v1 > v2)
					flag = true;
			//}
		}
		if(flag){
			new_ps->setPoint(count, p[0], p[1], p[2]);
			if(reversef2)
				new_ps->setNormal(count, -n2[i][0], -n2[i][1], -n2[i][2]);
			else
				new_ps->setNormal(count, n2[i][0], n2[i][1], n2[i][2]);
			count++;
		}
	}

	new_ps->_pointN = count;

	delete _func;
	_func = NULL;
	delete _ps;
	_ps = new_ps;

	delete _func2;
	_func2 = NULL;
	delete _ps2;
	_ps2 = NULL;

	//Timing & #Evaluation
	tdia = new TimeDialog;

	clock_t duration = clock() - start;
	float t = (float)(duration/ CLOCKS_PER_SEC);

	tdia->m_time = t;
	tdia->m_function = 0; //_func->count;
	tdia->m_cell = 0; //_func->getCellCount();

	mode = POINT;
	draw();
}

void COctPOUDoc::OnPoint1() 
{
	// TODO: 
	if(_ps == NULL)
		return;

	CFileDialog dia(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		            file_ex, NULL);
	if(dia.DoModal() != IDOK){
		return;
	}
	CString name = dia.GetPathName();
	FileManager fm;
	fm.writePointFile(_ps, name + ".pwn");
}

void COctPOUDoc::OnPoint2() 
{
	// TODO: 
	if(_ps2 == NULL)
		return;

	CFileDialog dia(FALSE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		            file_ex, NULL);
	if(dia.DoModal() != IDOK){
		return;
	}
	CString name = dia.GetPathName();
	FileManager fm;
	fm.writePointFile(_ps2, name + ".pwn");
}

void COctPOUDoc::OnLevel() 
{
	// TODO: 
	if(_ps == NULL)
		return;

	//Bounding box data
	float min[3], max[3];
	_ps->bound(min, max);

	//First polygonization case
	//Bounding box data is set to GUI
	if(_mesh == NULL){
		poly_dia->m_x1 = min[0];
		poly_dia->m_y1 = min[1];
		poly_dia->m_z1 = min[2];

		poly_dia->m_x2 = max[0];
		poly_dia->m_y2 = max[1];
		poly_dia->m_z2 = max[2];
	}

	if(poly_dia->DoModal() != IDOK)
		return;

	clock_t start = clock();

	float mid[3];
	mid[0] = 0.5f*(min[0] + max[0]);
	mid[1] = 0.5f*(min[1] + max[1]);
	mid[2] = 0.5f*(min[2] + max[2]);

	float sizeX = max[0] - min[0];
	float sizeY = max[1] - min[1];
	float sizeZ = max[2] - min[2];
	float size = max(sizeX, max(sizeY, sizeZ))*0.5f*func_dia->m_box;
	float maxC[3], minC[3];
	minC[0] = mid[0] - 1.05f*size;
	minC[1] = mid[1] - 1.05f*size;
	minC[2] = mid[2] - 1.05f*size;
	maxC[0] = mid[0] + 1.05f*size;
	maxC[1] = mid[1] + 1.05f*size;
	maxC[2] = mid[2] + 1.05f*size;

	if(_func == NULL){
		_func = new ImplicitPOU;
		_func->imp = new ImplicitOctTree(_ps, minC, maxC);
		_func->setMaxCellN(10000000);
	}
	
	_func->_max_level = poly_dia->m_level;
	_func->_tol = poly_dia->m_error*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	_func->_iso = poly_dia->m_iso*(float)sqrt(sizeX*sizeX + sizeY*sizeY + sizeZ*sizeZ);
	
	FILE* out = fopen("test.pwnC", "w");
	int N = _ps->_pointN;

	float *level = new float[N];
	float total = 0;
	for(int i=0; i<N; i++){
		float* p = _ps->_point[i];
		level[i] =  _func->level(p[0], p[1], p[2]);
		total += level[i];
	}
	total /= N;

	fprintf(out, "%d\n", N);
	for(i=0; i<N; i++){
		float* p = _ps->_point[i];
		fprintf(out, "%f %f %f\n", p[0], p[1], p[2]);
	}

	for(i=0; i<N; i++){
		float* p = _ps->_point[i];
		fprintf(out, "%f\n", 0.5*(level[i]-total)+0.5);
	}

	for(i=0; i<N; i++){
		float* p = _ps->_normal[i];
		fprintf(out, "%f %f %f\n", -p[0], -p[1], -p[2]);
	}
	delete[] level;

	fprintf(out, "AVE: %f\n", total);

	fclose(out);

	//Timing & #Evaluation
	tdia = new TimeDialog;

	clock_t duration = clock() - start;
	float t = (float)(duration/ CLOCKS_PER_SEC);

	tdia->m_time = t;
	tdia->m_function = _func->count;
	tdia->m_cell = _func->getCellCount();

	mode = FLAT;
	draw();
}

void COctPOUDoc::OnFunc() 
{
	// TODO: 
	if(func_dia->DoModal() != IDOK)
		return;
	delete _func;
	_func = NULL;

	OnPolygonize();
}
