// OctPOUDoc.h : COctPOUDoc 
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OCTPOUDOC_H__F74F528F_7D84_4CA1_8146_BBBC5AD343F6__INCLUDED_)
#define AFX_OCTPOUDOC_H__F74F528F_7D84_4CA1_8146_BBBC5AD343F6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "mpu_core/PointSet.h"
#include "FileManager.h"
#include "PolygonalMesh.h"
#include "Polygonizer.h"
#include "mpu_core/ImplicitOctTree.h"
#include "BooleanImplicit.h"
#include "BlendingImplicit.h"
#include "RayTracer.h"

#include "dialog/TimeDialog.h"
#include "dialog/PolygonizationDialog.h"
#include "dialog/BooleanDialog.h"
#include "dialog/BlendingDialog.h"
#include "dialog/BoundDialog.h"
#include "dialog/MoveDialog.h"
#include "dialog/FunctionDialog.h"

#define FLAT 0
#define WIRE 1
#define POINT 2
#define CONF 3
#define SMOOTH 4
#define RAY 5

class COctPOUDoc : public CDocument
{
public: 
	COctPOUDoc();
	DECLARE_DYNCREATE(COctPOUDoc)

public:
	ImplicitPOU* _func;
	ImplicitPOU* _func2;
	PolygonalMesh* _mesh;
	PointSet* _ps;
	PointSet* _ps2;
	PointSet* _ps2_tmp;
	PointSet* _ray_ps;

	//Dialogs
	TimeDialog* tdia;
	PolygonizationDialog* poly_dia;
	BooleanDialog* bool_dia;
	BlendingDialog* blend_dia;
	BoundDialog* bound_dia;
	MoveDialog* move_dia;
	FunctionDialog* func_dia;

	//Visualization Style
	int mode;

	CString file_data;
	
public:

//
	// ClassWizard
	//{{AFX_VIRTUAL(COctPOUDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// 
public:
	void createTempPS2();
	void moveSecondPoints();
	void draw();
	void drawMesh();
	virtual ~COctPOUDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// 
protected:
	//{{AFX_MSG(COctPOUDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnTime();
	afx_msg void OnFileSaveAs();
	afx_msg void OnPolygonize();
	afx_msg void OnFlat();
	afx_msg void OnPoint();
	afx_msg void OnWire();
	afx_msg void OnConf();
	afx_msg void OnSmooth();
	afx_msg void OnFlatGradient();
	afx_msg void OnBool();
	afx_msg void OnOpen2();
	afx_msg void OnMorph();
	afx_msg void OnSmoothNormal();
	afx_msg void OnRaytrace();
	afx_msg void OnMove();
	afx_msg void OnMerge();
	afx_msg void OnPoint1();
	afx_msg void OnPoint2();
	afx_msg void OnLevel();
	afx_msg void OnFunc();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ 

#endif // !defined(AFX_OCTPOUDOC_H__F74F528F_7D84_4CA1_8146_BBBC5AD343F6__INCLUDED_)
