// OctPOUView.cpp : COctPOUView 
//

#include "stdafx.h"
#include "OctPOU.h"

#include "OctPOUDoc.h"
#include "OctPOUView.h"

//#define PI 3.14159265

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COctPOUView

IMPLEMENT_DYNCREATE(COctPOUView, CView)

BEGIN_MESSAGE_MAP(COctPOUView, CView)
	//{{AFX_MSG_MAP(COctPOUView)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COctPOUView 

COctPOUView::COctPOUView()
{
	face_N = vertex_N = 0;

	eye[0] = 26;
	eye[1] = -48;
	eye[2] = 40;

	center[0] = 0.0;
	center[1] = 0.0;
	center[2] = 0.0;

	Rx = 0;
	Ry = -3; //-157; //60; //-33; //76;
	Rz = 122; //116; //29; //242; //23;
	
	/*
	Rx = 0;
	Ry = -45;
	Rz = 134;
	*/
	
	vx[0] = 0;
	vx[1] = 0;
	vx[2] = 1;

	vy[0] = -(float)(eye[1]/sqrt(eye[0]*eye[0]+eye[1]*eye[1]));
	vy[1] = (float)(eye[0]/sqrt(eye[0]*eye[0]+eye[1]*eye[1]));
	vy[2] = 0;

	vz[0] = -vy[1];
	vz[1] = vy[0];
	vz[2] = 0;

	//view_angle = 25.0f;
	//view_angle = 8.65;

	view_angle = 22.5;

	isLPressed = FALSE;
	isRPressed = FALSE;

	shift_x = 0;
	shift_y = 0;
	shift_z = 0;
}

COctPOUView::~COctPOUView()
{
}

BOOL COctPOUView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style |= WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COctPOUView 

void COctPOUView::OnDraw(CDC* pDC)
{
	COctPOUDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	wglMakeCurrent(pDC->m_hDC, m_hRC);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	TRACE("%f, %f\n", Ry, Rz);
//TRACE("%f\n", view_angle);

	glPushMatrix();
	glTranslatef(shift_x,shift_y,shift_z);
	//glTranslatef(0,0,10);
	glRotatef(Rx,vz[0],vz[1],vz[2]);
	glRotatef(Ry,vy[0],vy[1],vy[2]);
	glRotatef(Rz,vx[0],vx[1],vx[2]);
	
	//glTranslatef(0,0,-10);
	//glCallList(1);
	pDoc->drawMesh();
	//drawBoundBox();
	glPopMatrix();

	glFlush();
	SwapBuffers(wglGetCurrentDC());
	wglMakeCurrent(pDC->m_hDC, NULL);

	pDC->SetBkColor(RGB(255,255,255));
	pDC->SetTextColor(RGB(0,0,0));
	

	/*
	//int v = pDoc->current_vertex_N;
	CString str;
	//for(int i=v; i!= 0; i = i/10)
		//str = (char)((int)'0'+i%10) + str;
	str.Format("%d", vertex_N);
	pDC->TextOut(8,8,"Vertex:" +  str);
	//v = pDoc->current_face_N;
	//for(i=v; i!= 0; i = i/10)
		//str = (char)((int)'0'+i%10) + str;
	str.Format("%d", face_N);
	pDC->TextOut(8,25,"Face  :" +  str);*/
}

/////////////////////////////////////////////////////////////////////////////
// COctPOUView 

#ifdef _DEBUG
void COctPOUView::AssertValid() const
{
	CView::AssertValid();
}

void COctPOUView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COctPOUDoc* COctPOUView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COctPOUDoc)));
	return (COctPOUDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COctPOUView  

void COctPOUView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO:  
	int i;
	GLdouble up[3];
	GLdouble vector[3];
	GLdouble norm;

	CClientDC clientDC(this);

	wglMakeCurrent(clientDC.m_hDC, m_hRC);

	glViewport(0, 0, cx, cy);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//gluPerspective(3, (GLfloat)cx/(GLfloat)cy, 10.0, 4000.0);
	gluPerspective(view_angle, (GLfloat)cx/(GLfloat)cy, 10.0, 4000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	for(i=0; i<3; i++)
		vector[i] = center[i] - eye[i];

	up[0] =  vector[0] * vector[2];
	up[1] =  vector[1] * vector[2];
	up[2] =  vector[0] * vector[0] + vector[1] * vector[1];

	norm = up[0] * up[0] + up[1] * up[1] + up[2] * up[2];
	norm = sqrt(norm);
	for(i=0; i<3; i++)
		up[i] = up[i] / norm;
	
	gluLookAt(eye[0], eye[1], eye[2], center[0], center[1], center[2],
		up[0], up[1], up[2]);

	wglMakeCurrent(clientDC.m_hDC, NULL);
}

void COctPOUView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO:  
	wglDeleteContext(m_hRC);
}

int COctPOUView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: 
	PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		16,
		0,0,0,0,0,0,
		0,0,0,0,0,0,0,
		32,
		0,0,
		PFD_MAIN_PLANE,
		0,
		0,0,0
	};

	CClientDC  clientDC(this);

	int pixelFormat = ChoosePixelFormat(clientDC.m_hDC, &pfd);
	if(!SetPixelFormat(clientDC.m_hDC, pixelFormat, &pfd))
		return -1;

	m_hRC = wglCreateContext(clientDC.m_hDC);

	wglMakeCurrent(clientDC.m_hDC,m_hRC);
	initGL();
	wglMakeCurrent(clientDC.m_hDC,NULL);
	return 0;
}

void COctPOUView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO:  
	isRPressed = false;
	CView::OnRButtonUp(nFlags, point);
}

void COctPOUView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO:  
	isRPressed = true;
	px = point.x;
	py = point.y;
	CView::OnRButtonDown(nFlags, point);
}

void COctPOUView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO:  
	isLPressed = FALSE;
	CView::OnLButtonUp(nFlags, point);
}

void COctPOUView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO:  
	isLPressed = TRUE;
	px = point.x;
	py = point.y;
	CView::OnLButtonDown(nFlags, point);
}

void COctPOUView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO:  
	switch(nChar){
	case VK_UP:
		shift_z += 5;
		break;
	case VK_DOWN:
		shift_z -= 5;
		break;
	case VK_RIGHT:
		shift_x += 5;
		break;
	case VK_LEFT:
		shift_x -= 5;
		break;
	}
	CClientDC* dc = new CClientDC(this); 
	OnDraw(dc);
	delete dc;

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void COctPOUView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO:  
	if(isLPressed){
		int nx = point.x;
		int ny = point.y;
		
		Rz += (nx - px)/3;
		Ry += (ny - py)/3;
		px = nx;
		py = ny;
		CClientDC* dc = new CClientDC(this); 
		OnDraw(dc);
		delete dc;
	}
	else if(isRPressed){
		int nx = point.x;
		int ny = point.y;

		view_angle += (ny - py)/20.0f;
		px = nx;
		py = ny;
		CClientDC* dc = new CClientDC(this);

		RECT* rect = new RECT;
		GetClientRect(rect);
		OnSize(SIZE_RESTORED, rect->right, rect->bottom);
		delete rect;
		OnDraw(dc);
		delete dc;
	}

	CView::OnMouseMove(nFlags, point);
}

void COctPOUView::initGL()
{
	GLfloat light_position1[4] = {-52, -16, -50, 0};
	GLfloat light_position2[4] = {-26, -48, -50, 0};
	GLfloat light_position3[4] = { 16, -52, -50, 0};

	GLfloat direction1[3] = {52,16,50};
	GLfloat direction2[3] = {26,48,50};
	GLfloat direction3[3] = {-16,52,50};

	GLfloat light_position4[4] = {52, 16, 50, 0};
	GLfloat light_position5[4] = {26, 48, 50, 0};
	GLfloat light_position6[4] = {-16, 52, 50, 0};

	GLfloat direction4[3] = {-52,-16,-50};
	GLfloat direction5[3] = {-26,-48,-50};
	GLfloat direction6[3] = {16,-52,-50};

	GLfloat color1[4] = {1,0,0,1};
	GLfloat color2[4] = {0,1,0,1};
	GLfloat color3[4] = {0,0,1,1};

	GLfloat color4[4] = {1,0,0,1};
	GLfloat color5[4] = {0,1,0,1};
	GLfloat color6[4] = {0,0,1,1};
	
	/*
	GLfloat color1[4] = {0.7,0.7,0.7,0.7};
	GLfloat color2[4] = {0.7,0.7,0.7,0.7};
	GLfloat color3[4] = {0.7,0.7,0.7,0.7};

	GLfloat color4[4] = {0.7,0.7,0.7,0.7};
	GLfloat color5[4] = {0.7,0.7,0.7,0.7};
	GLfloat color6[4] = {0.7,0.7,0.7,0.7};
	*/
	
	
	
	GLfloat ambient[4] = {0.3f,0.3f,0.3f,0.5f};

	GLfloat material_color[4] = {1,1,1,0.3f};
	GLfloat material_specular[4] = {0.5,0.5,0.5,0.5};
	GLfloat material_ambient[4] = {0.0,0.0,0.0,0.0};

	glClearColor(1,1,1,0);
	//glClearColor(0,0,0,0);

	glLightfv(GL_LIGHT0, GL_POSITION, light_position1);
	glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, direction1);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, color1);
	glLightfv(GL_LIGHT0, GL_SPECULAR, color1);

	glLightfv(GL_LIGHT1, GL_POSITION, light_position2);
	glLightfv(GL_LIGHT1, GL_SPOT_DIRECTION, direction2);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, color2);
	glLightfv(GL_LIGHT1, GL_SPECULAR, color2);

	glLightfv(GL_LIGHT2, GL_POSITION, light_position3);
	glLightfv(GL_LIGHT2, GL_SPOT_DIRECTION, direction3);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, color3);
	glLightfv(GL_LIGHT2, GL_SPECULAR, color3);

	glLightfv(GL_LIGHT3, GL_POSITION, light_position4);
	glLightfv(GL_LIGHT3, GL_SPOT_DIRECTION, direction4);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, color4);
	glLightfv(GL_LIGHT3, GL_SPECULAR, color4);

	glLightfv(GL_LIGHT4, GL_POSITION, light_position5);
	glLightfv(GL_LIGHT4, GL_SPOT_DIRECTION, direction5);
	glLightfv(GL_LIGHT4, GL_DIFFUSE, color5);
	glLightfv(GL_LIGHT4, GL_SPECULAR, color5);

	glLightfv(GL_LIGHT5, GL_POSITION, light_position6);
	glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, direction6);
	glLightfv(GL_LIGHT5, GL_DIFFUSE, color6);
	glLightfv(GL_LIGHT5, GL_SPECULAR, color6);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);

	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_color);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_ambient);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 128);

	glEnable(GL_LIGHTING);

	/*
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHT2);
	*/
	
	glEnable(GL_LIGHT3);
	glEnable(GL_LIGHT4);
	glEnable(GL_LIGHT5);
	
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS);

	glEnable(GL_POINT_SMOOTH);
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);

	//glEnable(GL_LINE_SMOOTH);
	//glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);

	glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);

	glLineWidth(0.5);
	//glPointSize(1.0f);
	glPointSize(2.0);
	//glPointSize(10.0);

	//glEnable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); 
}

void COctPOUView::draw()
{
	CClientDC* dc = new CClientDC(this); 
	OnDraw(dc);
	delete dc;
}

void COctPOUView::flatShade(PolygonalMesh *mesh)
{
	glShadeModel(GL_SMOOTH);
	int face_N = mesh->face_N;
	int **face = mesh->face;
	int *poly_N = mesh->poly_N;
	float (*normal_f)[3] = mesh->normal_f;
	float (*vertex)[3] = mesh->vertex;
	for(int i=0; i<face_N; i++){
		int *f = face[i];
		int n = poly_N[i];
		if(f[0] < 0)
			continue;
		glBegin(GL_POLYGON);
			glNormal3fv(normal_f[i]);
			//glNormal3f(-normal_f[i][0], -normal_f[i][1], -normal_f[i][2]);
			for(int j=0; j<n; j++){
				glVertex3fv(vertex[f[j]]);
			}
		glEnd();
	}
}

void COctPOUView::smoothShade(PolygonalMesh *mesh)
{
	glShadeModel(GL_SMOOTH);
	int face_N = mesh->face_N;
	int **face = mesh->face;
	int *poly_N = mesh->poly_N;
	float (*normal)[3] = mesh->normal;
	float (*vertex)[3] = mesh->vertex;
	for(int i=0; i<face_N; i++){
		int *f = face[i];
		int n = poly_N[i];
		if(f[0] < 0)
			continue;
		glBegin(GL_POLYGON);
			for(int j=0; j<n; j++){
				glNormal3fv(normal[f[j]]);
				glVertex3fv(vertex[f[j]]);
			}
		glEnd();
	}
}

void COctPOUView::wireframe(PolygonalMesh *mesh)
{
	int vertex_N = mesh->vertex_N;
	int face_N = mesh->face_N;
	int **face = mesh->face;
	float (*normal)[3] = mesh->normal;
	float (*normal_f)[3] = mesh->normal_f;
	float (*vertex)[3] = mesh->vertex;
	int *poly_N = mesh->poly_N;

	glShadeModel(GL_SMOOTH);
	glDisable(GL_LIGHTING);
		
	glColor3f(0.0f, 0.0f, 0.0f);
	for(int i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;

		int p_N = poly_N[i];
		int *f = face[i];
		for(int j=0; j<p_N; j++){
			int i1 = f[j];
			int i2 = f[(j+1)%p_N];
			if(i1 > i2){
				glBegin(GL_LINES);
					glVertex3fv(vertex[i1]);
					glVertex3fv(vertex[i2]);
				glEnd();
			}
		}
	}

	glEnable(GL_LIGHTING);
	glColor3f(1.0f, 1.0f, 1.0f);
	float d = (float)(0.05*view_angle/22.5);
	for(i=0; i<face_N; i++){
		if(face[i][0] < 0)
			continue;

		int *f = face[i];
		int n = poly_N[i];
		if(f[0] < 0)
			continue;
		glBegin(GL_POLYGON);
			glNormal3fv(normal_f[i]);
			for(int j=0; j<n; j++){
				float p[3];
				int fj = f[j];
				p[0] = vertex[fj][0] - d*normal[fj][0];
				p[1] = vertex[fj][1] - d*normal[fj][1];
				p[2] = vertex[fj][2] - d*normal[fj][2];
				glVertex3fv(p);
			}
		glEnd();
	}

	glEnable(GL_LIGHTING);
}

void COctPOUView::drawPoint(PointSet *ps)
{
	glShadeModel(GL_SMOOTH);
	//glDisable(GL_LIGHTING);
	int vertex_N = ps->_pointN;
	float (*vertex)[3] = ps->_point;
	float (*normal)[3] = ps->_normal;
	glBegin(GL_POINTS);
	//glColor3f(0,0,0);
	for(int i=0; i<vertex_N; i++){
		//if(PolygonalMesh::DOT(normal[i], eye) < 0)
			//continue;
		glNormal3f(-normal[i][0], -normal[i][1], -normal[i][2]);
		glVertex3fv(vertex[i]);
	}
	glEnd();
	//glEnable(GL_LIGHTING);
}

void COctPOUView::drawConfidence(PointSet *ps)
{
	glShadeModel(GL_SMOOTH);
	glDisable(GL_LIGHTING);
	int vertex_N = ps->_pointN;
	float (*vertex)[3] = ps->_point;
	bool *bound = ps->_bound;
	float (*normal)[3] = ps->_normal;
	glBegin(GL_POINTS);
	for(int i=0; i<vertex_N; i++){
		float r, g, b;
	
		if(bound[i]){r=1; g=b=0;}
		else      {b=1; r=g=0;} 
		/*
GLfloat material_color[4] = {r,g,b,1};
glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_color);
		glNormal3f(-normal[i][0], -normal[i][1], -normal[i][2]);

  */

		glColor3f(r,g,b);
		glVertex3fv(vertex[i]);
	}
	glEnd();
	glEnable(GL_LIGHTING);
}

void COctPOUView::drawPointOutOfBox(PointSet *ps, float x1, float x2, float y1, float y2, float z1, float z2)
{
	glShadeModel(GL_SMOOTH);
	//glDisable(GL_LIGHTING);
	int vertex_N = ps->_pointN;
	float (*vertex)[3] = ps->_point;
	float (*normal)[3] = ps->_normal;
	glBegin(GL_POINTS);
	//glColor3f(0,0,0);
	for(int i=0; i<vertex_N; i++){
		//if(PolygonalMesh::DOT(normal[i], eye) < 0)
			//continue;
		float* v = vertex[i];
		if(v[0] < x1 || v[0] > x2 || v[1] < y1 || v[1] > y2 || v[2] < z1 || v[2] > z2){
			glNormal3f(-normal[i][0], -normal[i][1], -normal[i][2]);
			glVertex3fv(v);
		}
	}
	glEnd();
	//glEnable(GL_LIGHTING);
}
